package com.xefer.rebel;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * Catches all Exceptions and reports them
 *
 */
 
public class AuthenticationFilter implements Filter {

  /** name of the xbel document */
  String xbel;
  /** name of the storage location */
  String location;

  /** standard filter configuration */
  private FilterConfig config = null;

  /** 
   * initialization
   */
  public void init(FilterConfig config) throws ServletException {
  
    this.config = config;
    
    location = config.getServletContext().getInitParameter("xbel-location");
    xbel     = config.getServletContext().getInitParameter("xbel-document");
    
  }

  public void destroy() {
    config = null;
  }
  
  /**
   * Verifies the user and sets up the location of that user's document
   * User is always null in this implementation
   */

  public void doFilter(ServletRequest request, ServletResponse response,
                     FilterChain chain) throws IOException, ServletException {
    
    String  user      = getUser((HttpServletRequest) request);
    String  fullpath  = getDocumentLocation(user);
    
    request.setAttribute("com.xefer.rebel.xbel", fullpath);

    chain.doFilter(request, response);
    
  }
  
  /**
   *
   * Verifies that the user specified by the url is the same user that has 
   * provided authentication credentials.  This only used in multi-user
   * situations where the url has be rewritten by the apache mod_rewrite
   * package to include the user name on the query string.  This method
   * is stubbed out for this impelentation and returns null
   *
   * @param request HttpServletRequest the servlet request
   * @returns null always returns null for this implementation
   *
   */
   
  private String getUser(HttpServletRequest request) throws ResourceException {
  
    return null;
/*  
    String[] users      = request.getParameterValues("user");
    Principal principal = request.getUserPrincipal();
    
    // check that there is a user query parameter
    if (users == null) {
      throw new ResourceException(HttpServletResponse.SC_FORBIDDEN, "Must specify user");     
    }

    // 1 and only 1 user parameter expected
    if (users.length != 1) {
      throw new ResourceException(HttpServletResponse.SC_FORBIDDEN, "Multiple users specified"); 
    }
    
    // If no principal then this must be a method that doesn't require authorization, otherwise
    // compare to the user requested
    if(principal != null) {
      if(! users[0].equals(principal.getName())) {
        throw new ResourceException(HttpServletResponse.SC_FORBIDDEN, "Access denied");
      }
    }
    
    return users[0];
*/    
  }
  
  /**
   * Returns the fully-qualified location on the XBEL document
   *
   * @param user name of the user. Always null in this implementation
   */
   
  private String getDocumentLocation(String user) {
  
    return location + File.separator /*+ user + File.separator*/ + xbel;
  
  }
  
}